

/**
 * Die Superklasse als abstrakte Klasse, da man davon keine Instanz erzeugen können soll.
 */
abstract class MyAbstractContainer {
	protected Object [] _objs;
	protected int _size;

	public MyAbstractContainer (int capacity) {
		this._objs = new Object [capacity];
		this._size = 0;
	}
	
	public int capacity (){
		return _objs.length;
	}
	
	public int size (){
		return _size;
	}
	
	public Object get (int index) throws MyContainerException{
		if (index <0 || index >= _size){ 
		     //Hier muss man prüfen ob der index<size ist (index =4; size = 5. ABER Array Index 0,1,2,3 4 = 5).  
			 // Man sollte aber auch prüfen, dass der Index nicht kleiner 0 ist!!
				throw new MyContainerException ("Kein gueltiger Index");
		}
		return _objs[index];
	}
	
	public int find (Object obj){
		for (int i=0; i<_objs.length; i++){
			//Hier auch nur bis size() (nicht capacity!!) laufen, sonst bekommen Sie eine NullpointerException, wenn der index >size ist!!
			if ( _objs[i] == obj){ // == macht Vergleich Referenzadressen. "equals" auf "Inhalte" -> Parameter
				return i;
			}
		}
		return -1;
	}
	
	// So könnte man alle vorkommenden Objekte finden:
	public int[] findAll(Object obj){
		int [] indexes;
		int sizes = 0;
		for(int index = 0; index < size(); index++){
			if(_objs[index].equals(obj)){
				sizes++;
			}
		}
		indexes = new int[sizes];
		int current = 0;
		for(int index = 0; index < size(); index++){
			if(_objs[index].equals(obj)){
				indexes[current] = index;
				current++;
			}
		}
		if(indexes.length != 0)
			return indexes;
		else
			return new int[0]; //Leeres Array == nichts gefunden
	}
	
	
	
	@Override
	public String toString (){
		String ausgabe;
		
		ausgabe = this.getClass().getName() + " (Cap: " + capacity() + ", Size: " + size() + "):" + "\n";
		for ( int i=0; i < size(); i++){ // i <= size() -1
			ausgabe += _objs[i].toString() + "\n";
			
		}
		return ausgabe; 
	}
}
