

public class MyList extends MyAbstractContainer{

	public MyList (int capacity){
		super (capacity);
	}
	
	public void add (Object obj) throws MyContainerException{
		ensureObjsHasSpace();
		_objs[size()] = obj;
		_size +=1;
	}
	
	/* Hier sehen Sie gut, wozu private Methoden da sind.
	 * -> Die add-Methode ist viel leichter lesbar und aufgeräumter, als wenn der unten stehende Code auch in der add-Methode stehen würde.
	 */
	private void ensureObjsHasSpace(){
		if (capacity () <= size ()){
			Object [] temp = new Object [capacity () * 2];
			for (int i=0; i < _objs.length; i++){
				temp [i] = _objs [i];
			}
			_objs = temp;
		}
	}
	
	public boolean remove (Object obj){
		int pos = find(obj);
		if (pos == -1 ){
			return false;
			/*Hinweis zur Fehlerbehandlung: Hier reicht ein einfacher Rückgabewert. Hier eine Exception zu werfen wäre ungeschickt, weil, wenn Sie tatsächlich ein Objekt nicht finden, aber Sie wollen es entfernen, dann ist das ja nicht so schlimm. Sie geben dann als Feedback halt zurück, dass es nicht da war, falls das den User interessiert.
			*/
		}
		
		//Ab der gefundenen Position die Elemente eins nach vorne kopieren.
		for (int i = pos + 1; i < size(); i++){
			_objs[i - 1] = _objs[i];
		}		
        _objs[_size-1] = null; //letzten Eintrag auf null setzen, weil der ja jetzt nicht mehr da ist.		
		_size--;
		return true;
	}
	
	
	
	public static void main (String [] args){
		TestKlasse_Fahrzeug a = new TestKlasse_Auto("Mercedes", 2100.0f, 20000); //Auto
		TestKlasse_Fahrzeug b = new TestKlasse_Auto("Audi", 1900.0f, 0); //Auto
		TestKlasse_Fahrzeug c = new TestKlasse_Fahrrad("Bianchi", 10); //Fahrrad
		MyList test = new MyList (8);
		try 
		{
		 test.add(a); 
		 test.add(b);
		 test.add(c);
		}
		catch (MyContainerException e){
			System.out.println("Achtung!");
		}
		 System.out.println ("3 Elemente hinzugefuegt: " + "\n" + test.toString());
		 
		 System.out.println ();
		 test.remove(b);
		 
		 System.out.println ("Das erste Element wird geloescht: " + "\n" + test.toString());
	}
}
